/* constructor */
function Rating(rating, canvases, goodCtrl, badCtrl, info, trackId, counts) {
    this.rating = rating;
    this.selectedRating = rating;
    this.canvases = new Array();
    
    for (var i = 0; i < canvases.length; i++) {
	this.canvases.push(document.getElementById(canvases[i]));
    }
    
    this.goodCtrl = document.getElementById(goodCtrl);
    this.badCtrl  = document.getElementById(badCtrl);
    this.infoArea= document.getElementById(info);
    this.trackId = trackId;
    this.counts  = document.getElementById(counts);
    this.init();
};

/* set handlers */
Rating.prototype.init = function () {
    var oThis = this;
    this.http  = Ajax.getTransport();
    this.logged = true;
    this.voted  = false;
    this.enableControls(); 
};


/* handle mouse click. rate the video */
Rating.prototype.handleMouseClick = function (oEvent,rate) {
    if (this.voted) {
        return false;
    }
    
    if (!this.logged) {
	document.location = this.loginUrl;
        return false;
    }    
    
    if (rate == 'bad') {
	this.rate(-1);
    } else if (rate == 'good') {
	this.rate(1);
    } 
    return true;
};




/* Display current rating */
Rating.prototype.draw = function () {
    var i, o;
    i = Math.floor(this.selectedRating);
    o = new Number(this.selectedRating - i);
	
    for (var j = 0; j < this.canvases.length; j++) {
	if (o == 0) {
    	    this.canvases[j].style.width = (1 + 15) * i;
	} else {
    	    this.canvases[j].style.width = (1 + 15) * i + (1 + 15*o);
	}    
    }
    return;
};



/* */
Rating.prototype.rate = function (rating) {
    var http = this.http;
    var self = this;

    if (http.readyState != 0) {
        http.abort();
    }
    
    http.open("GET", "http://" + document.location.hostname + "/vote.html?rating="+rating+"&id="+this.trackId, true);
    http.onreadystatechange = function () {
    
            if (http.readyState != 4)
                return;

            if (http.status != '200') 
                return;
            
            if (http.responseText.length == 0)
                return;
            
            var result = JSON.parse(http.responseText);
            self.onVote(result);
    };

    http.send(null);
    return;    
};



/*    */
Rating.prototype.onVote = function(res) {
    this.disableControls();
    this.counts.innerHTML = res[0];
    this.selectedRating   = res[1];
    this.infoArea.innerHTML = "<div style='padding-top:11px;padding-top=13px;'>  !</div>";
    this.draw();    
};




Rating.prototype.enableControls = function() {
    var oThis = this;
    
    if (!this.goodCtrl || !this.badCtrl) {
	return;
    }

    this.goodCtrl.onclick = function (oEvent) {
        if (!oEvent) {
            oEvent = window.event;
        }
	
        return oThis.handleMouseClick(oEvent,'good');
    };
    

    this.badCtrl.onclick = function (oEvent) {
        if (!oEvent) {
            oEvent = window.event;
        }
	
        return oThis.handleMouseClick(oEvent,'bad');
    };
};    


Rating.prototype.disableControls = function() {
    this.badCtrl.onclick     = null;
    this.goodCtrl.onclick    = null;   
    this.badCtrl.style.display = 'none';
    this.goodCtrl.style.display = 'none';
};    



Rating.prototype.notLogged = function(url) {
    this.loginUrl = url;
    this.logged   = false;
};



Rating.prototype.alreadyVoted = function() {
    this.voted = true;
};
