HScroller = Class.create();
HScroller.prototype = {
    // Object.extend(this.options, options || {});
    initialize: function(id,opts) {
            this.container = $(id);
            this.options   = opts;
            this.dataCells = new Array();
            this.content   = new Array();

            this.start     = 0;
            
            /* create controls and table */
            var control, cell, table;
            
            table = document.createElement('TABLE');
            table.insertRow(0);
            
            /* left contol */
            cell = table.rows[0].insertCell(-1);
            this.leftControl = this.createLeftControl(cell);
            
            
            /* data cells */
            for (var i = 0; i < this.options.itemsCnt; i++) {
                cell = table.rows[0].insertCell(-1);
                cell.className = this.options.cellClass;
                cell.innerHTML = '&nbsp;'
                this.dataCells.push(cell);
            }            
            
            /* right control */
            cell = table.rows[0].insertCell(-1);
	    
            this.rightControl = this.createRightControl(cell);
            this.container.appendChild(table);
    },


    createLeftControl: function(cell) {
        return new HScroller.Control(cell,this,'&lt;');
    },
    
    createRightControl: function(cell) {
        return new HScroller.Control(cell,this,'&gt;');
    },

    
    pushData: function(html) {
        this.content.push(html);
        if (!this.rightControl.enabled && this.content.length > this.options.itemsCnt) {
            this.rightControl.enable();
        }
        this.redraw();
    },
    
    
    redraw: function() {
        if (this.content.length == 0) {
            return;
        }
        
        for (var i = 0; i < this.options.itemsCnt; i++) {
            if (i + this.start >= this.content.length) {
                return;
            }
            
            var content = this.content[i + this.start];
            this.dataCells[i].innerHTML = content;
        }
    },
    
    /* control callbacks */
    controlClicked: function (control,event) {
        if (control == this.leftControl) {

            this.rightControl.enable();
            this.start--;
            this.redraw();
            if (this.start == 0) {
                control.disable();
            }
        }
        
        if (control == this.rightControl) {
            this.leftControl.enable();
            this.start++;
            this.redraw();
            if (this.start + this.options.itemsCnt == this.content.length) {
                control.disable();
            }
        }
    }
};


/* Our ajaxed scroller */
RutubeScroller = Class.create();
Object.extend(RutubeScroller.prototype,HScroller.prototype);


RutubeScroller.prototype.createLeftControl = function(cell) {
    return new RutubeScroller.Control(cell,this,'/img/arrow_04l.gif', '/img/arrow_04l.gif', '/img/arrow_04ld.gif');
};

RutubeScroller.prototype.createRightControl = function(cell) {
    return new RutubeScroller.Control(cell,this,'/img/arrow_04r.gif', '/img/arrow_04r.gif', '/img/arrow_04rd.gif');
};


RutubeScroller.prototype.initialize = function(id,opts) {
    HScroller.prototype.initialize.call(this,id,opts);
    
    /* load itemsCnt + preload number io tracks */
    this.lastLoadedData = this.processXML(false);
    this.loadData(0,this.options.itemsCnt + this.options.preload);
};



RutubeScroller.prototype.loadData = function(offset,count) {
    var url_query = this.options.url.split('?');
    var url = url_query[0];
    var query = url_query[1] || '';
    var params;
    
    if (query.length > 0) {
        params = query.toQueryParams();
    } else {
        params = {};
    }
    
    this.loading = true; 
    params[this.options.startParam] = offset;
    params[this.options.countParam] = count;

    var self = this;
    var request = new Ajax.Request(
        url,
        {
            method: 'get',
            asynchronous: true,
            parameters: $H(params).toQueryString(),
            onComplete: function (req) {
                self.lastLoadedData = self.processXML(req.responseXML);
                for (var i = 0; i < self.lastLoadedData['size']; i++) {
                    self.pushData(self.lastLoadedData['items'][i]);
                }
                this.loading = false;
                this.rightControl.enable();
            }
        }
    );
};


RutubeScroller.prototype.processXML = function(xmlDoc) {
    var oRet = {
        total : 0,
        size  : 0,
        offset: 0,
        items : new Array()
    };


    if (xmlDoc === false) {
        return oRet;
    }

    var xDoc = xmlDoc.documentElement;

    oRet['total'] = xDoc.getAttribute('total');
    oRet['offset']= xDoc.getAttribute('offset');

    var items = xDoc.getElementsByTagName('item');
    oRet['size'] = items.length;
    
    for (var i = 0; i < items.length; i++) {
        oRet['items'].push(items[i].firstChild.nodeValue);
    }
    return oRet;
};



RutubeScroller.prototype.controlClicked = function (control,event) {
    if (control == this.rightControl) {
        if (this.content.length < this.lastLoadedData['total']) {
            this.loadData(this.content.length, this.options.preload);
            if (this.loading) {
                this.rightControl.disable();
            }
        }
    }
    return HScroller.prototype.controlClicked.call(this,control,event);
};




/* standart ugly controls */
HScroller.Control = Class.create();
HScroller.Control.prototype = {

    initialize: function(cell,scroller,inner,className) {
        this.cell = cell;
        this.scroller = scroller;
        this.cell.innerHTML = inner;
        this.enabled = true;
        
        if (className) {
            this.cell.className = className;
        }
    
        this.disable();
    },
    

    enable: function() {
        this.enabled = true;
        this.cell.onclick = this.clicked.bindAsEventListener(this);
        this.cell.onmouseover = this.hover.bindAsEventListener(this);
        this.cell.onmouseout = this.unhover.bindAsEventListener(this);
    },
    
    disable: function() {
        this.enabled = false;
        this.cell.onclick = null;        
        this.cell.onmouseover = null;
        this.cell.onmouseout = null;
    },
    
    clicked: function(e) {
        this.scroller.controlClicked(this,e);
    },
    
    /* not implemented here */
    hover: function() {
    },
    
    unhover: function() {
    }

};



/* Control for rutube scroller */
RutubeScroller.Control = Class.create();
Object.extend(RutubeScroller.Control.prototype,HScroller.Control.prototype);

RutubeScroller.Control.prototype.initialize = function(cell,scroller,aimg,himg,dimg) {
    this.activeImg = aimg;
    this.hoverImg = himg;
    this.disabledImg = dimg;
    this.currentImg  = new Image();
    
    HScroller.Control.prototype.initialize.call(this,cell,scroller,'');
    this.cell.innerHTML = '';
    var a = document.createElement('A');
    a.href="javascript:void(0)";
    a.border=0;
    this.currentImg.border =0 ;
    a.appendChild(this.currentImg);
    this.cell.appendChild(a);
};


RutubeScroller.Control.prototype.disable = function() {
    HScroller.Control.prototype.disable.call(this);
    this.currentImg.src = this.disabledImg;
};


RutubeScroller.Control.prototype.enable = function() {
    HScroller.Control.prototype.enable.call(this);
    this.currentImg.src = this.activeImg;
};


RutubeScroller.Control.prototype.hover = function() {
//    this.currentImg.src = this.hoverImg;
};

RutubeScroller.Control.prototype.unhover = function() {
//    this.currentImg.src = this.activeImg;
};

